diff --git a/imap/Makefile.am b/imap/Makefile.am
index 527b044f72..8bbbcb110c 100644
--- a/imap/Makefile.am
+++ b/imap/Makefile.am
@@ -20,5 +20,5 @@ AM_CPPFLAGS = -I$(top_srcdir) -I../intl
 noinst_LIBRARIES = libimap.a
 noinst_HEADERS = auth.h imap_private.h message.h
 
-libimap_a_SOURCES = auth.c auth_login.c browse.c command.c imap.c imap.h \
-	message.c utf7.c util.c $(AUTHENTICATORS) $(GSSSOURCES)
+libimap_a_SOURCES = auth.c auth_plain.c auth_login.c browse.c command.c \
+	imap.c imap.h message.c utf7.c util.c $(AUTHENTICATORS) $(GSSSOURCES)
diff --git a/imap/auth.c b/imap/auth.c
index 68dcb8647a..e2dcb3bef6 100644
--- a/imap/auth.c
+++ b/imap/auth.c
@@ -29,6 +29,7 @@
 #include "auth.h"
 
 static const imap_auth_t imap_authenticators[] = {
+  { imap_auth_plain, "plain" },
 #ifdef USE_SASL
   { imap_auth_sasl, NULL },
 #else
diff --git a/imap/auth.h b/imap/auth.h
index 63107947c9..9985d90c98 100644
--- a/imap/auth.h
+++ b/imap/auth.h
@@ -40,6 +40,7 @@ typedef struct
 } imap_auth_t;
 
 /* external authenticator prototypes */
+imap_auth_res_t imap_auth_plain (IMAP_DATA* idata, const char* method);
 #ifndef USE_SASL
 imap_auth_res_t imap_auth_anon (IMAP_DATA* idata, const char* method);
 imap_auth_res_t imap_auth_cram_md5 (IMAP_DATA* idata, const char* method);
diff --git a/imap/auth_plain.c b/imap/auth_plain.c
new file mode 100644
index 0000000000..561c3edefd
--- /dev/null
+++ b/imap/auth_plain.c
@@ -0,0 +1,62 @@
+/*
+ * Copyright (C) 1999-2001,2005,2009 Brendan Cully <brendan@kublai.com>
+ * Copyright (C) 2016 Pietro Cerutti <gahr@gahr.ch>
+ * 
+ *     This program is free software; you can redistribute it and/or modify
+ *     it under the terms of the GNU General Public License as published by
+ *     the Free Software Foundation; either version 2 of the License, or
+ *     (at your option) any later version.
+ * 
+ *     This program is distributed in the hope that it will be useful,
+ *     but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *     GNU General Public License for more details.
+ * 
+ *     You should have received a copy of the GNU General Public License
+ *     along with this program; if not, write to the Free Software
+ *     Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ */ 
+
+/* SASL PLAIN support */
+
+#if HAVE_CONFIG_H
+# include "config.h"
+#endif
+
+#include "mutt.h"
+#include "imap_private.h"
+#include "auth.h"
+
+/* imap_auth_plain: SASL PLAIN support */
+imap_auth_res_t imap_auth_plain (IMAP_DATA* idata, const char* method)
+{
+  char auth[STRING];
+  char buf[STRING];
+  size_t authlen;
+  size_t buflen;
+
+  if (mutt_account_getuser (&idata->conn->account))
+    return IMAP_AUTH_FAILURE;
+  if (mutt_account_getpass (&idata->conn->account))
+    return IMAP_AUTH_FAILURE;
+
+  mutt_message _("Logging in...");
+
+  authlen = snprintf (auth, sizeof (auth), "%s%c%s%c%s",
+      idata->conn->account.user, '\0', idata->conn->account.user, '\0',
+      idata->conn->account.pass);
+
+  buflen = snprintf (buf, sizeof (buf), "AUTHENTICATE PLAIN ");
+  mutt_to_base64 ((unsigned char *)buf+buflen, (unsigned char *)auth,
+      authlen, STRING-buflen);
+
+  if (!imap_exec (idata, buf, IMAP_CMD_FAIL_OK | IMAP_CMD_PASS))
+  {
+    mutt_clear_error(); /* clear "Logging in...".  fixes #3524 */
+    return IMAP_AUTH_SUCCESS;
+  }
+
+  mutt_error _("Login failed.");
+  mutt_sleep (2);
+  return IMAP_AUTH_FAILURE;
+}
